using System;
using System.Collections.Generic;
using System.Text;

namespace SharpProxyService
{
    public class PortMapper:SharpProxyInnerService 
    {
        public PortMapper() { }
        public static Config MyConfig;
        MyForm TheForm;

        public override void OnStart(string CWD)
        {
            MyConfig = new Config(CWD);
            MyConfig.ApplySettings();
        }

        public override void OnStop()
        {
            if (TheForm != null)
            {
                try
                {
                    TheForm.Dispose();
                }
                catch { }
            }


            lock (MyConfig.TheMaps) 
            {
                try
                {
                    foreach (Mapping M in MyConfig.TheMaps)
                    {
                        if (!M.Disposed)
                        {
                            M.Dispose();
                        }
                    }
                }
                catch { }
                MyConfig.TheMaps.Clear();
            
            }
            MyConfig = null;
        }

        public override string ServiceName
        {
            get { return "Port Mapper"; }
        }

        public override int ServiceVersion
        {
            get { return 1; }
        }

        public override void Show_Setting_For_User_To_Edit(System.Windows.Forms.Form TheMDIParent_Form)
        {
            if (TheForm != null) 
            {
                try
                {
                    TheForm.Dispose();
                }
                catch { }
            }

            TheForm = new MyForm();
            TheForm.MdiParent = TheMDIParent_Form;
            TheForm.Visible = true;
            TheForm.WindowState = System.Windows.Forms.FormWindowState.Maximized;
        }
    }
}
