using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.IO;
using System.Net;

namespace SharpProxyService
{
    public class Config
    {
        public List<Mapping> TheMaps = new List<Mapping>();
        string FileName;
        public DataTable CFG;
        public Config(string _CWD) 
        {
            FileName = _CWD + "\\PortMapper.xml";
            CFG = new DataTable("PORT MAPPER CONFIG");
            CFG.Columns.Add(new DataColumn("Local IP",typeof(string)));
            CFG.Columns.Add(new DataColumn("Local Port",typeof(Int32)));
            CFG.Columns.Add(new DataColumn("Remote IP",typeof(string)));
            CFG.Columns.Add(new DataColumn("Remote Port",typeof(Int32)));
            if (File.Exists(FileName))
            {
                try
                {
                    CFG.ReadXml(FileName);
                }
                catch { }
            }
            else 
            {
                try
                {
                    CFG.WriteXml(FileName);
                }
                catch { }
            }
        }

        public void ApplySettings() 
        {
            lock (TheMaps)
            {
                foreach (Mapping M in TheMaps) 
                {
                    if (!M.Disposed) 
                    {
                        M.Dispose();
                    }
                }

                TheMaps.Clear();
                foreach (DataRow DR in CFG.Rows)
                {
                    try
                    {
                        IPEndPoint LocalEP = new IPEndPoint(IPAddress.Parse(DR[0].ToString()), Convert.ToInt32(DR[1]));
                        IPEndPoint RemoteEP = new IPEndPoint(IPAddress.Parse(DR[2].ToString()), Convert.ToInt32(DR[3]));

                        TheMaps.Add(new Mapping(LocalEP, RemoteEP));

                    }
                    catch
                    {

                    }
                }
            }
        }

        public void SaveCfg() 
        {
            try
            {
                CFG.WriteXml(FileName);
            }
            catch { }
        }
    }
}
